<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="DoxyPress 1.2.10"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Commanders: D:/Mes documents/Trusty/Arduino/Libraries/Commanders/src/ButtonsCommanderSwitch.cpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="doxypress.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by DoxyPress -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Commanders
   </div>
   <div id="projectbrief">Arduino buttons/bus library</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by DoxyPress 1.2.10 -->
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('ButtonsCommanderSwitch_8cpp_source.html','');});
</script>
<div id="doc-content">
<div class="header">
  <div class="headertitle">
<div class="title">ButtonsCommanderSwitch.cpp</div>  </div>
  <div class="clear-floats"></div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*************************************************************</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment">project: &lt;Commanders&gt;</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment">author: &lt;Thierry PARIS&gt;</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment">description: &lt;Switch button with debounce.&gt;</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment">*************************************************************/</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;</div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="Commanders_8h.html">Commanders.h</a>&gt;</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#ifndef NO_BUTTONSCOMMANDER</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#ifndef NO_BUTTONSCOMMANDERSWITCH</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;</div><div class="line"><a name="l00011"></a><span class="lineno"><a class="line" href="classButtonsCommanderSwitch.html#ac0868173b88f84ea44ecdee9e0dfd82f">   11</a></span>&#160;<a class="code" href="classButtonsCommanderSwitch.html#ac0868173b88f84ea44ecdee9e0dfd82f">ButtonsCommanderSwitch::ButtonsCommanderSwitch</a>() : <a class="code" href="classButtonsCommanderButton.html">ButtonsCommanderButton</a>(<a class="code" href="Events_8h.html#a48ad4dd16b8e22f2c8bc92b154479e92">UNDEFINED_ID</a>)</div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;{</div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;    this-&gt;debounceDelay = 50;</div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;    this-&gt;lastSelectedPin = DP_INVALID;</div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;}</div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;</div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="keywordtype">void</span> beginItem(<a class="code" href="structEventPin.html">EventPin</a> *inpIdPin)</div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;{</div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;    <span class="keywordflow">if</span> (inpIdPin-&gt;<a class="code" href="structEventPin.html#a55bd77f9470bf8903042423278f950c2">Pin</a> != DP_INVALID)</div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;    {</div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;        pinMode2f(inpIdPin-&gt;<a class="code" href="structEventPin.html#a55bd77f9470bf8903042423278f950c2">Pin</a>, INPUT_PULLUP);</div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;    }</div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;}</div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;</div><div class="line"><a name="l00025"></a><span class="lineno"><a class="line" href="classButtonsCommanderSwitch.html#adf7871a996c39e3dcbc30d1ad98de2ba">   25</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="classButtonsCommanderSwitch.html#adf7871a996c39e3dcbc30d1ad98de2ba">ButtonsCommanderSwitch::begin</a>()</div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;{</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="preprocessor">#ifdef COMMANDERS_DEBUG_MODE</span></div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;    <span class="keywordflow">if</span> (this-&gt;EventPins.<a class="code" href="classCMDRSCHAINEDLIST.html#a604e8c770db9bc2a7b11fa2aacc56993">pFirst</a> == NULL)</div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;        Serial.println(F(<span class="stringliteral">&quot;This switch button have no ID defined : begin() must be called AFTER AddEvent !&quot;</span>));</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;    <a class="code" href="classCMDRSCHAINEDLISTITEM.html">CMDRSCHAINEDLISTITEM&lt;EventPin&gt;</a> *pCurr = this-&gt;EventPins.<a class="code" href="classCMDRSCHAINEDLIST.html#a604e8c770db9bc2a7b11fa2aacc56993">pFirst</a>;</div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;    <span class="keywordflow">while</span> (pCurr != NULL)</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;    {</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;        beginItem(pCurr-&gt;<a class="code" href="classCMDRSCHAINEDLISTITEM.html#aa4dd9b25f2fb55a906a2b052979e9cf2">Obj</a>);</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;        <span class="keywordtype">int</span> reading = digitalRead2f(pCurr-&gt;<a class="code" href="classCMDRSCHAINEDLISTITEM.html#aa4dd9b25f2fb55a906a2b052979e9cf2">Obj</a>-&gt;<a class="code" href="structEventPin.html#a55bd77f9470bf8903042423278f950c2">Pin</a>);</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;        <span class="keywordflow">if</span> (reading == LOW)</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;            this-&gt;lastSelectedPin = pCurr-&gt;<a class="code" href="classCMDRSCHAINEDLISTITEM.html#aa4dd9b25f2fb55a906a2b052979e9cf2">Obj</a>-&gt;<a class="code" href="structEventPin.html#a55bd77f9470bf8903042423278f950c2">Pin</a>;</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;        pCurr = pCurr-&gt;<a class="code" href="classCMDRSCHAINEDLISTITEM.html#a57edf0e3c4df958d02e9ef2d8af67c05">pNext</a>;</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;    }</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;}</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;</div><div class="line"><a name="l00046"></a><span class="lineno"><a class="line" href="classButtonsCommanderSwitch.html#a2b9922d2b262776d8b49909329280bc5">   46</a></span>&#160;<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> <a class="code" href="classButtonsCommanderButton.html#acbdd1d63fed7736c7358105428fbfd9c">ButtonsCommanderSwitch::GetId</a>(GPIO_pin_t inPin)<span class="keyword"> const</span></div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;<span class="keyword"></span>{</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;    <a class="code" href="classCMDRSCHAINEDLISTITEM.html">CMDRSCHAINEDLISTITEM&lt;EventPin&gt;</a> *pCurr = this-&gt;EventPins.<a class="code" href="classCMDRSCHAINEDLIST.html#a604e8c770db9bc2a7b11fa2aacc56993">pFirst</a>;</div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;    <span class="keywordflow">while</span> (pCurr != NULL)</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;    {</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;        <span class="keywordflow">if</span> (inPin == pCurr-&gt;<a class="code" href="classCMDRSCHAINEDLISTITEM.html#aa4dd9b25f2fb55a906a2b052979e9cf2">Obj</a>-&gt;<a class="code" href="structEventPin.html#a55bd77f9470bf8903042423278f950c2">Pin</a>)</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;            <span class="keywordflow">return</span> pCurr-&gt;<a class="code" href="classCMDRSCHAINEDLISTITEM.html#aa4dd9b25f2fb55a906a2b052979e9cf2">Obj</a>-&gt;<a class="code" href="structEventPin.html#ad356be83493e83623b5f8756f9f99808">Id</a>;</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;</div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;        pCurr = pCurr-&gt;<a class="code" href="classCMDRSCHAINEDLISTITEM.html#a57edf0e3c4df958d02e9ef2d8af67c05">pNext</a>;</div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;    }</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;    <span class="keywordflow">return</span> <a class="code" href="Events_8h.html#a48ad4dd16b8e22f2c8bc92b154479e92">UNDEFINED_ID</a>;</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;}</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;<span class="comment">// Returns the index of the new added position.</span></div><div class="line"><a name="l00060"></a><span class="lineno"><a class="line" href="classButtonsCommanderSwitch.html#a5b1a16f717941df169781ab96a5d1650">   60</a></span>&#160;<a class="code" href="structEventPin.html">EventPin</a> *<a class="code" href="classButtonsCommanderSwitch.html#a5b1a16f717941df169781ab96a5d1650">ButtonsCommanderSwitch::AddEvent</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> inId, <span class="keywordtype">int</span> inPin, <a class="code" href="Events_8h.html#a36239a7eea6194f04e73e80d7419490c">COMMANDERS_EVENT_TYPE</a> inEvent, <span class="keywordtype">int</span> inData)</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;{</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;    <a class="code" href="structEventPin.html">EventPin</a> *pIdpin = <span class="keyword">new</span> <a class="code" href="structEventPin.html">EventPin</a>();</div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;    pIdpin-&gt;<a class="code" href="structEventPin.html#a55bd77f9470bf8903042423278f950c2">Pin</a> = Arduino_to_GPIO_pin(inPin);</div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;    pIdpin-&gt;<a class="code" href="structEventPin.html#ad356be83493e83623b5f8756f9f99808">Id</a> = inId;</div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;    pIdpin-&gt;<a class="code" href="structEventPin.html#a8b4c6321f1b8abe7db2a5308f077533b">Event</a> = inEvent;</div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;    pIdpin-&gt;<a class="code" href="structEventPin.html#a76a1ef2eda3115e051f49861093cd6ff">Data</a> = inData;</div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;    this-&gt;EventPins.<a class="code" href="classCMDRSCHAINEDLIST.html#a9376873ee15cd2ad4f239b832c700c56">AddItem</a>(pIdpin);</div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;</div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;    <span class="keywordflow">return</span> pIdpin;</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;}</div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;</div><div class="line"><a name="l00072"></a><span class="lineno"><a class="line" href="classButtonsCommanderSwitch.html#ab4ff8f2eead168e08c2f385022c06a4a">   72</a></span>&#160;<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> <a class="code" href="classButtonsCommanderSwitch.html#ab4ff8f2eead168e08c2f385022c06a4a">ButtonsCommanderSwitch::loopOnePin</a>(GPIO_pin_t inPin, <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> inId, <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> inPreviousId,</div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;    <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> *apDebounceDelay, GPIO_pin_t *apLastSelectedPin,</div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;    <span class="keywordtype">int</span> *apLastButtonState, <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> *apLastDebounceTime, <span class="keywordtype">bool</span> inSendEvent)</div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;{</div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;    <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> haveFound = <a class="code" href="Events_8h.html#a48ad4dd16b8e22f2c8bc92b154479e92">UNDEFINED_ID</a>;</div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;</div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;    <span class="keywordflow">if</span> (inPin != DP_INVALID)</div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;    {</div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;        <span class="comment">// read the state of the switch into a local variable:</span></div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;        <span class="keywordtype">int</span> reading = digitalRead2f(inPin);</div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;</div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;        <span class="comment">// check to see if you just pressed the button </span></div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;        <span class="comment">// (i.e. the input went from HIGH to LOW, inverted by INPUT_PULLUP), and you&#39;ve waited </span></div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;        <span class="comment">// long enough since the last press to ignore any noise:  </span></div><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;</div><div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;        <span class="comment">// If the switch changed, due to noise or pressing:</span></div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;        <span class="keywordflow">if</span> (reading != *apLastButtonState)</div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;        {</div><div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;            <span class="comment">// reset the debouncing timer</span></div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;            *apLastButtonState = reading;</div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;            *apLastDebounceTime = millis();</div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;            <span class="keywordflow">return</span> haveFound;</div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;        }</div><div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;</div><div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;        <span class="keywordflow">if</span> (*apLastDebounceTime &gt; 0 &amp;&amp; (millis() - *apLastDebounceTime) &gt; *apDebounceDelay)</div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;        {</div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;            <span class="comment">// whatever the reading is at, it&#39;s been there for longer</span></div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;            <span class="comment">// than the debounce delay, so take it as the actual current state:</span></div><div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;</div><div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;            <span class="comment">// if the button state has changed:</span></div><div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;            <span class="keywordflow">if</span> (reading == LOW)</div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;            {</div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;                <span class="comment">// raise the event for the new pin.</span></div><div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;                <span class="keywordflow">if</span> (inSendEvent)</div><div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;                    <a class="code" href="classCommanders.html#a7adbe54da67e90e0d39b58d69ac3add0">Commanders::RaiseEvent</a>(inId, <a class="code" href="Events_8h.html#a36239a7eea6194f04e73e80d7419490caebdb45ee96bd05e90e9e633c114e9cba">COMMANDERS_EVENT_MOVE</a>, <a class="code" href="Events_8h.html#a347ec2e7ad5bc98b641a887ce34cc2baa1675bf6790ab941818b2623b710d9826">COMMANDERS_MOVE_ON</a>);</div><div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;                <span class="comment">//haveFound = inId;</span></div><div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;                *apLastSelectedPin = inPin;</div><div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;            }</div><div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;            <span class="keywordflow">else</span></div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;            {</div><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;                <span class="keywordflow">if</span> (inSendEvent)</div><div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;                    <a class="code" href="classCommanders.html#a7adbe54da67e90e0d39b58d69ac3add0">Commanders::RaiseEvent</a>(inPreviousId, <a class="code" href="Events_8h.html#a36239a7eea6194f04e73e80d7419490caebdb45ee96bd05e90e9e633c114e9cba">COMMANDERS_EVENT_MOVE</a>, <a class="code" href="Events_8h.html#a347ec2e7ad5bc98b641a887ce34cc2baa72085934c5621169aa9f5e3f7a32a7c6">COMMANDERS_MOVE_OFF</a>);</div><div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;            }</div><div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;            *apLastDebounceTime = 0;</div><div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;        }</div><div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;</div><div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;        <span class="comment">// save the reading.  Next time through the loop,</span></div><div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;        <span class="comment">// it&#39;ll be the lastButtonState:</span></div><div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;        *apLastButtonState = reading;</div><div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;    }</div><div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;</div><div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;    <span class="keywordflow">return</span> haveFound;        </div><div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;}</div><div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;</div><div class="line"><a name="l00126"></a><span class="lineno"><a class="line" href="classButtonsCommanderSwitch.html#ac5acada95c180aa8011e8b4c4ba3e6ce">  126</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="classButtonsCommanderSwitch.html#ac5acada95c180aa8011e8b4c4ba3e6ce">ButtonsCommanderSwitch::beforeFirstLoop</a>()</div><div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;{</div><div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;    <a class="code" href="classCMDRSCHAINEDLISTITEM.html">CMDRSCHAINEDLISTITEM&lt;EventPin&gt;</a> *pCurr = this-&gt;EventPins.<a class="code" href="classCMDRSCHAINEDLIST.html#a604e8c770db9bc2a7b11fa2aacc56993">pFirst</a>;</div><div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;    <span class="keywordflow">while</span> (pCurr != NULL)</div><div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;    {</div><div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;        <span class="keywordflow">if</span> (pCurr-&gt;<a class="code" href="classCMDRSCHAINEDLISTITEM.html#aa4dd9b25f2fb55a906a2b052979e9cf2">Obj</a>-&gt;<a class="code" href="structEventPin.html#a55bd77f9470bf8903042423278f950c2">Pin</a> != DP_INVALID)</div><div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;        {</div><div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;            <span class="comment">// Initialize first switch state at start</span></div><div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;            <span class="keywordtype">int</span> reading = digitalRead2f(pCurr-&gt;<a class="code" href="classCMDRSCHAINEDLISTITEM.html#aa4dd9b25f2fb55a906a2b052979e9cf2">Obj</a>-&gt;<a class="code" href="structEventPin.html#a55bd77f9470bf8903042423278f950c2">Pin</a>);</div><div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;</div><div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;            <a class="code" href="classCommanders.html#a7adbe54da67e90e0d39b58d69ac3add0">Commanders::RaiseEvent</a>(pCurr-&gt;<a class="code" href="classCMDRSCHAINEDLISTITEM.html#aa4dd9b25f2fb55a906a2b052979e9cf2">Obj</a>-&gt;<a class="code" href="structEventPin.html#ad356be83493e83623b5f8756f9f99808">Id</a>, <a class="code" href="Events_8h.html#a36239a7eea6194f04e73e80d7419490caebdb45ee96bd05e90e9e633c114e9cba">COMMANDERS_EVENT_MOVE</a>, reading == LOW ? <a class="code" href="Events_8h.html#a347ec2e7ad5bc98b641a887ce34cc2baa1675bf6790ab941818b2623b710d9826">COMMANDERS_MOVE_ON</a> : <a class="code" href="Events_8h.html#a347ec2e7ad5bc98b641a887ce34cc2baa72085934c5621169aa9f5e3f7a32a7c6">COMMANDERS_MOVE_OFF</a>);</div><div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;</div><div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;            <span class="keywordflow">if</span> (reading == LOW)</div><div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;                this-&gt;lastSelectedPin = pCurr-&gt;<a class="code" href="classCMDRSCHAINEDLISTITEM.html#aa4dd9b25f2fb55a906a2b052979e9cf2">Obj</a>-&gt;<a class="code" href="structEventPin.html#a55bd77f9470bf8903042423278f950c2">Pin</a>;</div><div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;</div><div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;            this-&gt;lastButtonState = reading;</div><div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;        }</div><div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;</div><div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;        pCurr = pCurr-&gt;<a class="code" href="classCMDRSCHAINEDLISTITEM.html#a57edf0e3c4df958d02e9ef2d8af67c05">pNext</a>;</div><div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;    }</div><div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;</div><div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;}</div><div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;</div><div class="line"><a name="l00149"></a><span class="lineno"><a class="line" href="classButtonsCommanderSwitch.html#a3e66f87ce692b0524bf9940dec663d21">  149</a></span>&#160;<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> <a class="code" href="classButtonsCommanderSwitch.html#a3e66f87ce692b0524bf9940dec663d21">ButtonsCommanderSwitch::loop</a>()</div><div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;{</div><div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;<span class="preprocessor">#ifdef COMMANDERS_DEBUG_MODE</span></div><div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;    <span class="keywordflow">if</span> (this-&gt;EventPins.<a class="code" href="classCMDRSCHAINEDLIST.html#a604e8c770db9bc2a7b11fa2aacc56993">pFirst</a> == NULL)</div><div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;        Serial.println(F(<span class="stringliteral">&quot;This switch button have no ID defined : call AddEvent() and begin() !&quot;</span>));</div><div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;</div><div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;    <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> haveFound = <a class="code" href="classButtonsCommanderSwitch.html#ab4ff8f2eead168e08c2f385022c06a4a">ButtonsCommanderSwitch::loopOnePin</a>(this-&gt;EventPins.<a class="code" href="classCMDRSCHAINEDLIST.html#ae382ce65496e09ba16dfa0fc6f311a27">pCurrentItem</a>-&gt;<a class="code" href="classCMDRSCHAINEDLISTITEM.html#aa4dd9b25f2fb55a906a2b052979e9cf2">Obj</a>-&gt;<a class="code" href="structEventPin.html#a55bd77f9470bf8903042423278f950c2">Pin</a>, this-&gt;EventPins.pCurrentItem-&gt;Obj-&gt;Id, </div><div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;        this-&gt;GetId(this-&gt;lastSelectedPin),</div><div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;        &amp;this-&gt;debounceDelay, &amp;this-&gt;lastSelectedPin,</div><div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;        &amp;this-&gt;lastButtonState, &amp;this-&gt;lastDebounceTime, <span class="keyword">false</span>);</div><div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;</div><div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;    <span class="keywordflow">if</span> (haveFound != <a class="code" href="Events_8h.html#a48ad4dd16b8e22f2c8bc92b154479e92">UNDEFINED_ID</a>)</div><div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;        <a class="code" href="classCommanders.html#a7adbe54da67e90e0d39b58d69ac3add0">Commanders::RaiseEvent</a>(haveFound, this-&gt;EventPins.<a class="code" href="classCMDRSCHAINEDLIST.html#ae382ce65496e09ba16dfa0fc6f311a27">pCurrentItem</a>-&gt;<a class="code" href="classCMDRSCHAINEDLISTITEM.html#aa4dd9b25f2fb55a906a2b052979e9cf2">Obj</a>-&gt;<a class="code" href="structEventPin.html#a8b4c6321f1b8abe7db2a5308f077533b">Event</a>, this-&gt;EventPins.pCurrentItem-&gt;Obj-&gt;Data);</div><div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;</div><div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;    this-&gt;EventPins.<a class="code" href="classCMDRSCHAINEDLIST.html#a7c95325c818d2e63d6ccf0b7f5250103">NextCurrent</a>();</div><div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;</div><div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;    <span class="keywordflow">return</span> haveFound;</div><div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;}</div><div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;</div><div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;<span class="preprocessor">#ifdef COMMANDERS_PRINT_COMMANDERS</span></div><div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;<span class="keywordtype">void</span> ButtonsCommanderSwitch::printCommander()</div><div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;{</div><div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;    Serial.println(F(<span class="stringliteral">&quot;    Switch&quot;</span>));</div><div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;</div><div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;    <a class="code" href="classCMDRSCHAINEDLISTITEM.html">CMDRSCHAINEDLISTITEM&lt;EventPin&gt;</a> *pCurr = this-&gt;EventPins.<a class="code" href="classCMDRSCHAINEDLIST.html#a604e8c770db9bc2a7b11fa2aacc56993">pFirst</a>;</div><div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;    <span class="keywordflow">while</span> (pCurr != NULL)</div><div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;    {</div><div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;        Serial.print(F(<span class="stringliteral">&quot;        Event - Pin: &quot;</span>));</div><div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;        Serial.print(GPIO_to_Arduino_pin(pCurr-&gt;<a class="code" href="classCMDRSCHAINEDLISTITEM.html#aa4dd9b25f2fb55a906a2b052979e9cf2">Obj</a>-&gt;<a class="code" href="structEventPin.html#a55bd77f9470bf8903042423278f950c2">Pin</a>));</div><div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;        Serial.print(F(<span class="stringliteral">&quot; / Id: &quot;</span>));</div><div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;        Serial.print(pCurr-&gt;<a class="code" href="classCMDRSCHAINEDLISTITEM.html#aa4dd9b25f2fb55a906a2b052979e9cf2">Obj</a>-&gt;<a class="code" href="structEventPin.html#ad356be83493e83623b5f8756f9f99808">Id</a>);</div><div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;        Serial.print(F(<span class="stringliteral">&quot; / Event type: &quot;</span>));</div><div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;        <a class="code" href="classCommanders.html#a5594e42de65bbf0bff7065c2eaaa3c7e">Commanders::printEventType</a>(pCurr-&gt;<a class="code" href="classCMDRSCHAINEDLISTITEM.html#aa4dd9b25f2fb55a906a2b052979e9cf2">Obj</a>-&gt;<a class="code" href="structEventPin.html#a8b4c6321f1b8abe7db2a5308f077533b">Event</a>, <span class="keyword">true</span>);</div><div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;        <a class="code" href="classCommanders.html#af67a26985403e912486b851e3b44a6d6">Commanders::printEventData</a>(pCurr-&gt;<a class="code" href="classCMDRSCHAINEDLISTITEM.html#aa4dd9b25f2fb55a906a2b052979e9cf2">Obj</a>-&gt;<a class="code" href="structEventPin.html#a8b4c6321f1b8abe7db2a5308f077533b">Event</a>, pCurr-&gt;<a class="code" href="classCMDRSCHAINEDLISTITEM.html#aa4dd9b25f2fb55a906a2b052979e9cf2">Obj</a>-&gt;<a class="code" href="structEventPin.html#a76a1ef2eda3115e051f49861093cd6ff">Data</a>);</div><div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;        Serial.println(F(<span class="stringliteral">&quot;&quot;</span>));</div><div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;</div><div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;        pCurr = pCurr-&gt;<a class="code" href="classCMDRSCHAINEDLISTITEM.html#a57edf0e3c4df958d02e9ef2d8af67c05">pNext</a>;</div><div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;    }</div><div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;}</div><div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;<span class="preprocessor">#endif</span></div><div class="ttc" id="classCommanders_html_af67a26985403e912486b851e3b44a6d6"><div class="ttname"><a href="classCommanders.html#af67a26985403e912486b851e3b44a6d6">Commanders::printEventData</a></div><div class="ttdeci">static void printEventData(COMMANDERS_EVENT_TYPE inEventType, int inEventData)</div></div>
<div class="ttc" id="classCommanders_html_a5594e42de65bbf0bff7065c2eaaa3c7e"><div class="ttname"><a href="classCommanders.html#a5594e42de65bbf0bff7065c2eaaa3c7e">Commanders::printEventType</a></div><div class="ttdeci">static void printEventType(COMMANDERS_EVENT_TYPE inEventType, bool inDataFollow)</div></div>
<div class="ttc" id="classCMDRSCHAINEDLIST_html_a7c95325c818d2e63d6ccf0b7f5250103"><div class="ttname"><a href="classCMDRSCHAINEDLIST.html#a7c95325c818d2e63d6ccf0b7f5250103">CMDRSCHAINEDLIST::NextCurrent</a></div><div class="ttdeci">void NextCurrent()</div><div class="ttdef"><b>Definition:</b> <a href="Chain_8hpp_source.html#l00085">Chain.hpp:85</a></div></div>
<div class="ttc" id="classButtonsCommanderSwitch_html_a3e66f87ce692b0524bf9940dec663d21"><div class="ttname"><a href="classButtonsCommanderSwitch.html#a3e66f87ce692b0524bf9940dec663d21">ButtonsCommanderSwitch::loop</a></div><div class="ttdeci">unsigned long loop()</div><div class="ttdef"><b>Definition:</b> <a href="ButtonsCommanderSwitch_8cpp_source.html#l00149">ButtonsCommanderSwitch.cpp:149</a></div></div>
<div class="ttc" id="Events_8h_html_a347ec2e7ad5bc98b641a887ce34cc2baa72085934c5621169aa9f5e3f7a32a7c6"><div class="ttname"><a href="Events_8h.html#a347ec2e7ad5bc98b641a887ce34cc2baa72085934c5621169aa9f5e3f7a32a7c6">COMMANDERS_MOVE_OFF</a></div><div class="ttdef"><b>Definition:</b> <a href="Events_8h_source.html#l00021">Events.h:21</a></div></div>
<div class="ttc" id="Events_8h_html_a347ec2e7ad5bc98b641a887ce34cc2baa1675bf6790ab941818b2623b710d9826"><div class="ttname"><a href="Events_8h.html#a347ec2e7ad5bc98b641a887ce34cc2baa1675bf6790ab941818b2623b710d9826">COMMANDERS_MOVE_ON</a></div><div class="ttdef"><b>Definition:</b> <a href="Events_8h_source.html#l00020">Events.h:20</a></div></div>
<div class="ttc" id="classButtonsCommanderSwitch_html_ab4ff8f2eead168e08c2f385022c06a4a"><div class="ttname"><a href="classButtonsCommanderSwitch.html#ab4ff8f2eead168e08c2f385022c06a4a">ButtonsCommanderSwitch::loopOnePin</a></div><div class="ttdeci">static unsigned long loopOnePin(GPIO_pin_t inPin, unsigned long inId, unsigned long inPreviousId, unsigned long *apDebounceDelay, GPIO_pin_t *apLastSelectedPin, int *apLastButtonState, unsigned long *apLastDebounceTime, bool inSendEvent = true)</div><div class="ttdef"><b>Definition:</b> <a href="ButtonsCommanderSwitch_8cpp_source.html#l00072">ButtonsCommanderSwitch.cpp:72</a></div></div>
<div class="ttc" id="classCMDRSCHAINEDLIST_html_a9376873ee15cd2ad4f239b832c700c56"><div class="ttname"><a href="classCMDRSCHAINEDLIST.html#a9376873ee15cd2ad4f239b832c700c56">CMDRSCHAINEDLIST::AddItem</a></div><div class="ttdeci">void AddItem(T *inpt)</div><div class="ttdef"><b>Definition:</b> <a href="Chain_8hpp_source.html#l00061">Chain.hpp:61</a></div></div>
<div class="ttc" id="structEventPin_html_a76a1ef2eda3115e051f49861093cd6ff"><div class="ttname"><a href="structEventPin.html#a76a1ef2eda3115e051f49861093cd6ff">EventPin::Data</a></div><div class="ttdeci">int Data</div><div class="ttdef"><b>Definition:</b> <a href="ButtonsCommanderSwitch_8hpp_source.html#l00019">ButtonsCommanderSwitch.hpp:19</a></div></div>
<div class="ttc" id="classButtonsCommanderSwitch_html_ac5acada95c180aa8011e8b4c4ba3e6ce"><div class="ttname"><a href="classButtonsCommanderSwitch.html#ac5acada95c180aa8011e8b4c4ba3e6ce">ButtonsCommanderSwitch::beforeFirstLoop</a></div><div class="ttdeci">void beforeFirstLoop()</div><div class="ttdef"><b>Definition:</b> <a href="ButtonsCommanderSwitch_8cpp_source.html#l00126">ButtonsCommanderSwitch.cpp:126</a></div></div>
<div class="ttc" id="Events_8h_html_a36239a7eea6194f04e73e80d7419490c"><div class="ttname"><a href="Events_8h.html#a36239a7eea6194f04e73e80d7419490c">COMMANDERS_EVENT_TYPE</a></div><div class="ttdeci">COMMANDERS_EVENT_TYPE</div><div class="ttdef"><b>Definition:</b> <a href="Events_8h_source.html#l00025">Events.h:25</a></div></div>
<div class="ttc" id="classButtonsCommanderSwitch_html_a5b1a16f717941df169781ab96a5d1650"><div class="ttname"><a href="classButtonsCommanderSwitch.html#a5b1a16f717941df169781ab96a5d1650">ButtonsCommanderSwitch::AddEvent</a></div><div class="ttdeci">EventPin * AddEvent(unsigned long inId, int inPin, COMMANDERS_EVENT_TYPE inEvent = COMMANDERS_EVENT_MOVEPOSITIONID, int inData = 0)</div><div class="ttdef"><b>Definition:</b> <a href="ButtonsCommanderSwitch_8cpp_source.html#l00060">ButtonsCommanderSwitch.cpp:60</a></div></div>
<div class="ttc" id="classCMDRSCHAINEDLIST_html_ae382ce65496e09ba16dfa0fc6f311a27"><div class="ttname"><a href="classCMDRSCHAINEDLIST.html#ae382ce65496e09ba16dfa0fc6f311a27">CMDRSCHAINEDLIST::pCurrentItem</a></div><div class="ttdeci">CMDRSCHAINEDLISTITEM&lt; T &gt; * pCurrentItem</div><div class="ttdef"><b>Definition:</b> <a href="Chain_8hpp_source.html#l00039">Chain.hpp:39</a></div></div>
<div class="ttc" id="structEventPin_html_ad356be83493e83623b5f8756f9f99808"><div class="ttname"><a href="structEventPin.html#ad356be83493e83623b5f8756f9f99808">EventPin::Id</a></div><div class="ttdeci">unsigned long Id</div><div class="ttdef"><b>Definition:</b> <a href="ButtonsCommanderSwitch_8hpp_source.html#l00017">ButtonsCommanderSwitch.hpp:17</a></div></div>
<div class="ttc" id="classButtonsCommanderButton_html_acbdd1d63fed7736c7358105428fbfd9c"><div class="ttname"><a href="classButtonsCommanderButton.html#acbdd1d63fed7736c7358105428fbfd9c">ButtonsCommanderButton::GetId</a></div><div class="ttdeci">unsigned long GetId() const </div><div class="ttdef"><b>Definition:</b> <a href="ButtonsCommanderButton_8hpp_source.html#l00030">ButtonsCommanderButton.hpp:30</a></div></div>
<div class="ttc" id="classCMDRSCHAINEDLISTITEM_html_a57edf0e3c4df958d02e9ef2d8af67c05"><div class="ttname"><a href="classCMDRSCHAINEDLISTITEM.html#a57edf0e3c4df958d02e9ef2d8af67c05">CMDRSCHAINEDLISTITEM::pNext</a></div><div class="ttdeci">CMDRSCHAINEDLISTITEM * pNext</div><div class="ttdef"><b>Definition:</b> <a href="Chain_8hpp_source.html#l00013">Chain.hpp:13</a></div></div>
<div class="ttc" id="Events_8h_html_a36239a7eea6194f04e73e80d7419490caebdb45ee96bd05e90e9e633c114e9cba"><div class="ttname"><a href="Events_8h.html#a36239a7eea6194f04e73e80d7419490caebdb45ee96bd05e90e9e633c114e9cba">COMMANDERS_EVENT_MOVE</a></div><div class="ttdef"><b>Definition:</b> <a href="Events_8h_source.html#l00029">Events.h:29</a></div></div>
<div class="ttc" id="classCMDRSCHAINEDLISTITEM_html"><div class="ttname"><a href="classCMDRSCHAINEDLISTITEM.html">CMDRSCHAINEDLISTITEM&lt; EventPin &gt;</a></div></div>
<div class="ttc" id="classCMDRSCHAINEDLISTITEM_html_aa4dd9b25f2fb55a906a2b052979e9cf2"><div class="ttname"><a href="classCMDRSCHAINEDLISTITEM.html#aa4dd9b25f2fb55a906a2b052979e9cf2">CMDRSCHAINEDLISTITEM::Obj</a></div><div class="ttdeci">T * Obj</div><div class="ttdef"><b>Definition:</b> <a href="Chain_8hpp_source.html#l00011">Chain.hpp:11</a></div></div>
<div class="ttc" id="classCMDRSCHAINEDLIST_html_a604e8c770db9bc2a7b11fa2aacc56993"><div class="ttname"><a href="classCMDRSCHAINEDLIST.html#a604e8c770db9bc2a7b11fa2aacc56993">CMDRSCHAINEDLIST::pFirst</a></div><div class="ttdeci">CMDRSCHAINEDLISTITEM&lt; T &gt; * pFirst</div><div class="ttdef"><b>Definition:</b> <a href="Chain_8hpp_source.html#l00037">Chain.hpp:37</a></div></div>
<div class="ttc" id="classButtonsCommanderSwitch_html_adf7871a996c39e3dcbc30d1ad98de2ba"><div class="ttname"><a href="classButtonsCommanderSwitch.html#adf7871a996c39e3dcbc30d1ad98de2ba">ButtonsCommanderSwitch::begin</a></div><div class="ttdeci">void begin()</div><div class="ttdef"><b>Definition:</b> <a href="ButtonsCommanderSwitch_8cpp_source.html#l00025">ButtonsCommanderSwitch.cpp:25</a></div></div>
<div class="ttc" id="structEventPin_html_a55bd77f9470bf8903042423278f950c2"><div class="ttname"><a href="structEventPin.html#a55bd77f9470bf8903042423278f950c2">EventPin::Pin</a></div><div class="ttdeci">GPIO_pin_t Pin</div><div class="ttdef"><b>Definition:</b> <a href="ButtonsCommanderSwitch_8hpp_source.html#l00016">ButtonsCommanderSwitch.hpp:16</a></div></div>
<div class="ttc" id="structEventPin_html"><div class="ttname"><a href="structEventPin.html">EventPin</a></div><div class="ttdef"><b>Definition:</b> <a href="ButtonsCommanderSwitch_8hpp_source.html#l00014">ButtonsCommanderSwitch.hpp:14</a></div></div>
<div class="ttc" id="Events_8h_html_a48ad4dd16b8e22f2c8bc92b154479e92"><div class="ttname"><a href="Events_8h.html#a48ad4dd16b8e22f2c8bc92b154479e92">UNDEFINED_ID</a></div><div class="ttdeci">#define UNDEFINED_ID</div><div class="ttdef"><b>Definition:</b> <a href="Events_8h_source.html#l00038">Events.h:38</a></div></div>
<div class="ttc" id="classButtonsCommanderButton_html"><div class="ttname"><a href="classButtonsCommanderButton.html">ButtonsCommanderButton</a></div><div class="ttdef"><b>Definition:</b> <a href="ButtonsCommanderButton_8hpp_source.html#l00015">ButtonsCommanderButton.hpp:15</a></div></div>
<div class="ttc" id="classCommanders_html_a7adbe54da67e90e0d39b58d69ac3add0"><div class="ttname"><a href="classCommanders.html#a7adbe54da67e90e0d39b58d69ac3add0">Commanders::RaiseEvent</a></div><div class="ttdeci">static unsigned long RaiseEvent(unsigned long inId, COMMANDERS_EVENT_TYPE inEvent = COMMANDERS_EVENT_MOVEPOSITIONID, int inData = 0)</div><div class="ttdef"><b>Definition:</b> <a href="Commanders_8cpp_source.html#l00027">Commanders.cpp:27</a></div></div>
<div class="ttc" id="structEventPin_html_a8b4c6321f1b8abe7db2a5308f077533b"><div class="ttname"><a href="structEventPin.html#a8b4c6321f1b8abe7db2a5308f077533b">EventPin::Event</a></div><div class="ttdeci">COMMANDERS_EVENT_TYPE Event</div><div class="ttdef"><b>Definition:</b> <a href="ButtonsCommanderSwitch_8hpp_source.html#l00018">ButtonsCommanderSwitch.hpp:18</a></div></div>
<div class="ttc" id="classButtonsCommanderSwitch_html_ac0868173b88f84ea44ecdee9e0dfd82f"><div class="ttname"><a href="classButtonsCommanderSwitch.html#ac0868173b88f84ea44ecdee9e0dfd82f">ButtonsCommanderSwitch::ButtonsCommanderSwitch</a></div><div class="ttdeci">ButtonsCommanderSwitch()</div><div class="ttdef"><b>Definition:</b> <a href="ButtonsCommanderSwitch_8cpp_source.html#l00011">ButtonsCommanderSwitch.cpp:11</a></div></div>
<div class="ttc" id="Commanders_8h_html"><div class="ttname"><a href="Commanders_8h.html">Commanders.h</a></div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- Generated by DoxyPress 1.2.10 -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_d41d8cd98f00b204e9800998ecf8427e.html">src</a></li><li class="navelem"><b>ButtonsCommanderSwitch.cpp</b></li>
    <li class="footer">Generated on mer. oct. 18 2017 17:55:02 for Commanders &nbsp; by
    <a href="http://www.copperspice.com/documentation-doxypress.html">
    <img class="footer" src="doxypress.png" alt="DoxyPress"/></a> 1.2.10 </li>
  </ul>
</div>
</body>
</html>
